
/*
 *  lookup.c (tfident)
 *
 *  Lookups our port pair in /proc/net/tcp, returning the UID of the user
 *  that owns the connection.
 *  
 */

#include <stdio.h>
#include <sys/types.h>

int
lookup (unsigned int cl_port, unsigned int cr_port)
{
    char fbuf[256];
    long dontcarel;
    unsigned int sl_port, sr_port, dontcarei;
    uid_t uid;
    FILE *f;  
    
    /* 
     *  This is why we are linux specific.  Linux keeps all of this
     *  information in /proc/net/tcp.
     *
     */

    if ((f = fopen("/proc/net/tcp", "r")) == NULL)
    {
        /* er.. */
	printf("%u , %u : ERROR : UNKNOWN-ERROR\r\n", cl_port, cr_port);
	exit(-1);
    }

    /* initial line is header */
    if (fgets(fbuf, sizeof(fbuf), f) == NULL)
    {
        /* er.. */
	printf("%u , %u : ERROR : UNKNOWN-ERROR\r\n", cl_port, cr_port);
	exit(-1);
    }

    /* loop through, and find our port pair */
    while (fgets(fbuf, sizeof(fbuf), f) != NULL)
    {
        /* parse using sscanf */
	if (sscanf(fbuf, "%d: %lx:%x %lx:%x %x %lx:%lx %x:%lx %lx %d %ld %d",
	           &dontcarei, &dontcarel, &sl_port, &dontcarel, &sr_port, 
		   &dontcarei, &dontcarel, &dontcarel, &dontcarei, &dontcarel,
		   &dontcarel, &uid, &dontcarel, &dontcarei) < 12)
	{
	    printf("%u , %u : ERROR : UNKNOWN-ERROR\r\n", cl_port, cr_port);
	    exit(-1);
	}

	/* is it what we're looking for? */
	if (sl_port == cl_port && cr_port == sr_port)
	    return uid;

    }

    /* never found our pair */
    printf("%u , %u : ERROR : NO-USER\r\n", cl_port, cr_port);
    exit(-1);
}

	           



